package com.mortals.xhx.module.datum.service.impl;
import cn.hutool.core.util.RandomUtil;
import com.mortals.framework.model.PageInfo;
import com.mortals.xhx.common.utils.StringUtils;
import com.mortals.xhx.common.utils.WXCreateQRCodeUtil;
import com.mortals.xhx.module.matter.model.MatterDatumEntity;
import com.mortals.xhx.module.matter.service.MatterDatumService;
import lombok.Getter;
import org.springframework.beans.BeanUtils;

import java.io.File;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.function.Function;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import com.mortals.framework.service.impl.AbstractCRUDServiceImpl;
import com.mortals.framework.exception.AppException;
import com.mortals.framework.model.Context;
import com.mortals.xhx.module.datum.dao.DatumFillQrcodeDao;
import com.mortals.xhx.module.datum.model.DatumFillQrcodeEntity;
import com.mortals.xhx.module.datum.service.DatumFillQrcodeService;
import lombok.extern.slf4j.Slf4j;
/**
* DatumFillQrcodeService
* 材料填单二维码 service实现
*
* @author zxfei
* @date 2025-06-12
*/
@Service("datumFillQrcodeService")
@Slf4j
public class DatumFillQrcodeServiceImpl extends AbstractCRUDServiceImpl<DatumFillQrcodeDao, DatumFillQrcodeEntity, Long> implements DatumFillQrcodeService {

    @Value("${upload.path}")
    @Getter
    private String filePath;
    @Value("${wx.appId}")
    @Getter
    private String appId;
    @Value("${wx.appSecret}")
    @Getter
    private String appSecret;

    private static String PATH = "/page_td/cailiaoInfo/cailiaoInfo?id=";

    @Autowired
    private MatterDatumService matterDatumService;

    @Override
    public void createQrcode() {
        List<DatumFillQrcodeEntity> saveList = new ArrayList<>();
        List<MatterDatumEntity> allDatum = matterDatumService.getAllList();
        String rootPath = this.filePath;
        String prePath = "/file/preview/qrcode/";
        String allPath = rootPath + prePath;
        File pathDir = new File(allPath);
        if (!pathDir.exists()) {
            pathDir.mkdirs();
        }
        String newName = RandomUtil.randomNumbers(12) + ".jpg";
        String filePathAll = allPath + newName;

        for(MatterDatumEntity item:allDatum){
            String result = WXCreateQRCodeUtil.createWeiXinQRCode(PATH+item.getId(),appId,appSecret,filePathAll);
            log.info("材料id:{},生成二维码地址:{}",item.getId(),result);
            if(StringUtils.isNotEmpty(result)) {
                DatumFillQrcodeEntity qrcodeEntity = new DatumFillQrcodeEntity();
                qrcodeEntity.setDatumId(item.getId());
                qrcodeEntity.setQrcode(prePath+newName);
                qrcodeEntity.setCreateUserId(1L);
                qrcodeEntity.setCreateTime(new Date());
                saveList.add(qrcodeEntity);
            }
        }
        this.save(saveList);
    }
}